package handler

import (
	"time"

	"github.com/gofiber/fiber/v3"
)

func Healthz(name, version string) fiber.Handler {
	start := time.Now()
	return func(c fiber.Ctx) error {
		return c.JSON(fiber.Map{
			"name":     name,
			"version":  version,
			"start_at": start,
			"uptime":   time.Since(start).String(),
		})
	}
}
